/*
* LaGUI: A graphical application framework.
* Copyright (C) 2022-2023 Wu Yiming
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "la_5.h"

static const char *entries[]={
"Set Min","调成最小",
"Set Max","调成最大",
"Restore Default","恢复默认值",
"Paste","粘贴",
"Copy","复制",
"Copy Selection","复制选择内容",
"Get File Path","获取文件路径",
"Show Splash","显示闪屏",
"🡻 Minimized","🡻 隐藏的面板",
"Length","长度",
"Fullscreen","全屏",
"Multiply (component)","相乘（分量）",
"Cross","叉乘",
"Dot","点乘",
"Append","追加",
"Restore","恢复",
"Combine 🡲","合并 🡲",
"New Layout","新布局",
"Divide (component)","相除（分量）",
"Color Picker Gamma","拾色器伽玛",
"Color:","颜色：",
"Normalize","归一化",
"General Type Of The File","文件的一般类型",
"File exists","文件已存在",
"Selected file already exists. Overwrite the file?","所选文件已存在。覆盖该文件？",
"Color","颜色",
"Route","路径",
"Driver","驱动",
"Auxiliary","辅助",
"Fold","折叠",
"Restore Layout","恢复布局",
"Maximize","最大化",
"Background color of the canvas","画布的背景颜色",
"Create a new window","创建一个新窗口",
"Cosine","余弦",
"Log","对数",
"Tangent","正切",
"Subtract","相减",
"Cycle All Layouts In Current Window","在当前窗口中循环所有布局",
"The Title/Name Of A Panel","面板的标题/名字",
"Themes Loaded In The Program","该程序已加载的主题",
"Arcsin","反正弦",
"Atan2","正切2",
"Divide","相除",
"Arccosine","反余切",
"Sine","正弦",
"Arctangent","余弦",
"Mod","取余",
"Power","指数",
"Framerate limiter for drawing the user interface","绘制整个用户界面的帧率限制",
"Dock some panels here.","将面板停靠到这里。",
"User Preferences","用户偏好设置",
"Drivers","驱动",
"Controllers","控制器",
"Data Manager","数据管理",
"System","系统",
"Input Mapper","输入映射",
"Terminal","终端",
"Controlling","控制",
"Tools","工具",
"Texture Inspector","纹理检查工具",
"Yiming's Blog","吴奕茗的博客",
"Details","细节",
"Add","相加",
"Ignore The Statement","忽略该陈述",
"Histories","历史",
"Show Border","显示边框",
"显示 User Preferences","显示 用户设置",
"Range of the random values","随机值的范围",
"RGB to OKHSL","RGB 到 OKHSL",
"Show ","显示 ",
"Discard And Quit","放弃并退出",
"Make Transform","生成变换",
"OKHSL to RGB","OKHSL 到 RGB",
"Vector Math","矢量数学",
"Show User Preferences","显示用户设置",
"Refresh","刷新",
"Random","随机",
"Move","移动",
"Split","拆分",
"Visualizer","可视化",
"Matrix","矩阵",
"Configure","配置",
"Small Math","小数学",
"Save","保存",
"Math","数学",
"Comment","评论",
"Values","数值",
"Save All Modified","保存所有已修改",
"Transform","变换",
"Switch","切换",
"Mapper","映射",
"Binding","绑定",
"You still have unsaved/unassigned datablocks:","您还有未保存/未指定文件的数据块：",
"If you exit the program now, you will lose those changes.","如果现在退出，这些更改将丢失",
"Input Mapping:","输入映射：",
"Undo","撤销",
"UDF Manager","UDF 管理",
"Please select a controller.","请选择一个控制器",
"Normal","普通",
"px","px",
"Information","信息",
"Width,Height","宽度,高度",
"Floating Panel:","浮动面板：",
"Solid Shadow Length","阴影长度",
"Wire Transparency","线条透明度",
"Cursor Alpha","指针透明度",
"Selected Face Transparency","已选择面的透明度",
"Wire color slices","线条颜色数",
"Scrolling Speed","滚动速度",
"Redo","重做",
"A graphical user interface application toolkit","一个图形界面应用程序框架",
"Meshes:","网格：",
"Add Resource Folder","添加资源文件夹",
"User Interactions:","用户交互：",
"Enable Translation:","使用翻译：",
"Active","活动的",
"Inactive Mix","不活动的",
"Edit","编辑",
"Delete Rack","删除挂架",
"Panel Animation Speed","面板动画速度",
"Active Theme","当前主题",
"Panel doesn't have configurable property.","面板没有可调节属性。",
"Font Size","字符尺寸",
"Margin Size","留白尺寸",
"Add Rack","添加挂架",
"Left,Right,Top,Bottom","左,右,上,下",
"Tooltip Close Distance","工具提示关闭距离",
"UDF Manager Default View:","默认UDF管理视图：",
"Alpha","透明度",
"Other Entries","其他条目",
"Interface:","界面：",
"Settings","设置",
"New Panel","新面板",
"Font Size:","字符尺寸：",
"Border","边框",
"Accent Color:","亮点颜色：",
"Wire Saturation","线条饱和度",
"Text","文字",
"LaGUI application framework is made by Wu Yiming.","LaGUI应用程序框架由吴奕茗制作。",
"Refresh Controllers","刷新控制器",
"Dock","停靠",
"Panel Multisample:","面板多重采样",
"Files","文件",
"None","无",
"Text Active","文字激活",
"Shadow Alpha","阴影透明度",
"Input device handling:","输入设备行为：",
"Add Node","添加节点",
"Hide","隐藏",
"Viewing Texture:","查看贴图：",
"Stylus Device","手写笔设备",
"Base Color:","基础颜色：",
"Margin Size:","留白尺寸：",
"Eraser Device","橡皮擦设备",
"Animation Speed","动画速度",
"File Dialog","选择文件",
"Row Height:","行高：",
"Border:","边缘：",
"Selected Vertex Transparency","已选择点的透明度",
"Quit","退出",
"Dump Untranslated Text","导出未翻译的词句",
"History","历史",
"Margins:","留白：",
"Zoom Speed 2D","平面缩放速度",
"Idle time","静止时间",
"UDF Extensions:","UDF扩展：",
"Options","选项",
"Top Framerate","最高帧率",
"Goto","前往",
"Cursor:","光标：",
"Yes Or No","是/否",
"Selection Alpha","选择区域透明度",
"Widgets:","挂件：",
"Pads/Joysticks:","手柄/操纵杆：",
"Edge Brightness","边缘亮度",
"Valuator Threshold","数值挂件拖动阈值",
"Save as","另存为",
"Switch Layout","切换布局",
"Adaptive","自适应",
"Cancel","取消",
"File","文件",
"Show","显示 ",
"Remove","删除",
"Wire saggyness","连线松弛程度",
"Inactive Saturation","未激活饱和度",
"Get Folder Path","获得文件夹路径",
"New Window","新窗口",
"Resource Folders","资源文件夹",
"Basics:","基础：",
"Selected Edge Transparency","已选择边的透明度",
"Read","读取",
"Wire thickness","线条粗细",
"Panel Activator","面板激活工具",
"Data Blocks","数据块",
"Transparency:","透明度：",
"Language:","语言：",
"Wacom Devices:","Wacom 设备：",
"Move Rack","移动挂架",
"Yes","是",
"Interface Size","界面尺寸",
"Nodes:","节点：",
"Translation:","翻译：",
"Delete","删除",
"(C)Yiming Wu","(C) 吴奕茗",
"Wire Brightness","连线亮度",
"Rebuild Input Mapping","重生成输入映射",
"Save Preferences","保存偏好设置",
"Close","关闭",
"Paddings:","外留白：",
"Function Test","功能测试",
"Edge Transparency","边透明度",
"Insert Rack","插入挂架",
"Line Width:","线宽度：",
"Add Page","新建页",
"Viewing","正查看",
"Controller:","控制器：",
"Size","尺寸",
"File Size","文件尺寸",
"Last Modified On","最后修改于",
"Resource","资源",
"New File","新文件",
"… Bookmarks","… 书签",
"Bytes","字节",
"Logic Drives","逻辑驱动器",
"Folder","文件夹",
"Confirm","确认",
"Display","显示",
"Show","显示",
"Theme","主题",
"Input","输入",
"File Name","文件名",
"Up","上一级",
"Device Graphics","设备图形信息",
"Authors","作者",
"LaGUI information","LaGUI 信息",
"Show","显示",
"Version","版本",
0,0};

void la_MakeTranslations(){
    transSetLanguage("zh-CN");
    for(int i=0;;i++){if(!entries[i*2])break;
        transNewEntry(entries[i*2],entries[i*2+1]);
    }
}
